# importar las librerías de Python necesarias
from musicpy import *		
from musicpy.daw import *
import sys
import random

# leer los parámetros con los que queremos correr el programa
ficheroconfig = './config.txt'
config = {}
for line in open(ficheroconfig):
	if line == '\n':
		continue
	thisname = line.split('#')[0].split('=')[0].strip()
	thisvalue = line.split('#')[0].split('=')[1].strip()
	config[thisname] = thisvalue
#print(config)

# convertir a enteros los parámetros que sean números
config['bpm'] = int(config['bpm'])
config['silencios'] = int(config['silencios'])
config['volumenperc'] = int(config['volumenperc'])
config['volumeninst'] = int(config['volumeninst'])
config['volumenvoz'] = int(config['volumenvoz'])

seq = ''
for line in open(config['seqfasta']):
	if line.startswith('>'):
		continue
	seq += line.strip()
seq = seq.upper().replace('T','D').replace('N','B')


new_song = daw(3, name=config['ficheromp3'])

new_song.load(0, config['percdir'])
new_song.load(1, config['instdir'])
new_song.load(2, config['vozdir'])


# PERCUSION
notes = []
intervals = []
for base in seq:
	octave = 4
	duration = 1/6
	channel = 0
	thisinterval = 1/6

	if config['silencios']:
		variation = random.randrange(100)
	else:
		variation = 100

	if variation < config['silencios']:
		volume = 0
	else:
		volume = config['volumenperc']

	#print(base, str(octave), str(duration), str(volume))
	notes.append(note(base, num=octave, duration=duration, volume=volume, channel=channel))
	intervals.append(thisinterval)

perc = chord(notes=notes, interval=intervals)


# INSTRUMENTO
notes = []
intervals = []
for base in seq:
	octave = 4
	duration = 1/6
	channel = 0
	thisinterval = 1/6

	if config['silencios']:
		variation = random.randrange(100)
	else:
		variation = 100

	if variation < config['silencios']:
		volume = 0
	else:
		volume = config['volumeninst']

	notes.append(note(base, num=octave, duration=duration, volume=volume, channel=channel))
	intervals.append(thisinterval)

inst = chord(notes=notes, interval=intervals)


# VOZ
notes = []
intervals = []
for base in seq:
	octave = 4
	duration = 1/6
	channel = 0
	thisinterval = 1/6

	if config['silencios']:
		variation = random.randrange(100)
	else:
		variation = 100

	if variation < config['silencios']:
		volume = 0
	else:
		volume = config['volumenvoz']

	notes.append(note(base, num=octave, duration=duration, volume=volume, channel=channel))
	intervals.append(thisinterval)

voz = chord(notes=notes, interval=intervals)



# RENDER
sonification = P([perc,inst,voz],
					bpm = config['bpm'],
					start_times=[0,0,0],
					daw_channels=[0,1,2]
					)

new_song.export(sonification, bpm=config['bpm'], mode='mp3', filename=config['ficheromp3'] + '.mp3', show_msg=True)

sys.exit()
